//
//  lariat-online/include/ReadoutError.h    (W.Badgett)
//
//  Description of one LArIAT readout error
//

#include <iostream>
#include <vector>

#ifndef _ReadoutError_h
#define _ReadoutError_h

class ReadoutError
{
 public:

#pragma pack(push,1)

  typedef struct ReadoutError_t
  {
    uint32_t fragmentSize;
    uint32_t fragmentType;
    uint32_t runNumber;
    uint32_t spillNumber;
    uint32_t timeStamp;
    char   * what;
  } ReadoutError_t;

#pragma pack(pop)

  ReadoutError();

  ReadoutError_t readoutError;

  uint32_t streamToBuffer(std::ostream& buffer);
  uint32_t fillFromBuffer(std::istream& buffer);
  void print(std::ostream& os = std::cout);
};

#endif
